// ContractsViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "ContractsViewDlg.h"
#include "Data.h"
#include "Search.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContractsViewDlg dialog

CContractsViewDlg::CContractsViewDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CContractsViewDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CContractsViewDlg)
	m_AirlineName = _T("");
	m_FirstTravelDate = time_t(0);
	m_FirstTicketDate = time_t(0);
	m_HotDeal = FALSE;
	m_LastTicketDate = time_t(0);
	m_LastTravelDate = time_t(0);
	m_SeeAirDeals = FALSE;

	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	pData = new CData;
	pFlt = new CFilter;

/*	rtfPrefix = "{\\rtf1\\ansi\\deff0\\deftab720{\\fonttbl{\\f0\\froman "
                "Times New Roman;}}\n{\\colortbl\\red0\\green0\\blue0;}\n"
                "\\deflang1033\\pard\\tx360\\tx720\\tx1080\\tx1440\\tx1800"
                "\\tx2160\\tx2520\\tx2880\\tx3240\\tx3600\\tx3960\\tx4320"
                "\\tx4680\\tx5040\\tx5400\\tx5760\\tx6120"
                "\\tx6480\\plain\\f3\\fs20 ";

	rtfPostfix = "\n\\par }";
*/
	//this is the prefix I got from what the RichCtrl's in the Entry form create
	rtfPrefix = "{\\rtf1\\ansi\\deff0\\deftab720{\\fonttbl{\\f0\\fswiss MS Sans Serif;}{\\f1\\froman\\fcharset2 Symbol;}{\\f2\\fswiss\\fprq2 System;}}";

	
	
	
	
	
//				"{\\colortbl\\red0\\green0\\blue0;\\red255\\green0\\blue0;}"
//				"\\deflang1033\\pard\\plain\\f0\\fs17 ";


	//this is the prefix from codeguru.com and it doesn't really make a difference
//	rtfPrefix = "{\\rtf1\\ansi\\deff0\\deftab720{\\fonttbl{\\f0\\froman "
//                "Times New Roman;}}\n{\\colortbl\\red0\\green0\\blue0;}\n"
//               "\\deflang1033\\pard\\tx360\\tx720\\tx1080\\tx1440\\tx1800"
//               "\\tx2160\\tx2520\\tx2880\\tx3240\\tx3600\\tx3960\\tx4320"
 //              "\\tx4680\\tx5040\\tx5400\\tx5760\\tx6120"
 //               "\\tx6480\\plain\\f3\\fs20 ";
	//simple postfix
	rtfPostfix = "\n\\par }";

	//this is to make sure RTF doesn't carry over to the next line
	rtfBridge = "\\plain\\f0\\fs17\\ul0";

	//to seperate out the feilds
	rtfReturn = "\n\\par\n\\par";

	//to make the "title" of the column BOLD
	rtfTitle = "\\b\\fs30\\ul ";


}

void CContractsViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CContractsViewDlg)
	DDX_Control(pDX, IDC_RESULTS, ctr_results);
	DDX_Control(pDX, IDC_TYPEDEAL_LIST, m_TypeofDeal);
	DDX_Control(pDX, IDC_MAJORDESTINATION_LIST, m_ctlMajorDestination);
	DDX_Control(pDX, IDC_GOODFOR_LIST, m_ctlGoodFor);
	DDX_Text(pDX, IDC_AIRLINENAME_EDIT, m_AirlineName);
	DDX_Text(pDX, IDC_FIRSTTRAVELDATE_EDIT, m_FirstTravelDate);
	DDX_Text(pDX, IDC_FIRSTTICKETDATE_EDIT, m_FirstTicketDate);
	DDX_Check(pDX, IDC_HOTDEAL_CHECK, m_HotDeal);
	DDX_Text(pDX, IDC_LASTTICKETDATE_EDIT, m_LastTicketDate);
	DDX_Text(pDX, IDC_LASTTRAVELDATE_EDIT, m_LastTravelDate);
	DDX_Control(pDX, IDC_MAIN, ctr_main);
	DDX_Check(pDX, IDC_SEEAIRDEALS_CHECK, m_SeeAirDeals);	
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CContractsViewDlg, CDialog)
	//{{AFX_MSG_MAP(CContractsViewDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_NEWSEARCH_BUTTON, OnNewsearchButton)
	ON_BN_CLICKED(IDC_MOVEFIRST_BUTTON, OnMovefirstButton)
	ON_BN_CLICKED(IDC_MOVEPREV_BUTTON, OnMoveprevButton)
	ON_BN_CLICKED(IDC_MOVENEXT_BUTTON, OnMovenextButton)
	ON_BN_CLICKED(IDC_MOVELAST_BUTTON, OnMovelastButton)
	ON_CBN_SELCHANGE(IDC_RESULTS, OnSelchangeResults)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CContractsViewDlg message handlers

BOOL CContractsViewDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// going to the search dialog
	CSearch dlgSearch;
	dlgSearch.pData = pData;
	dlgSearch.pFlt = pFlt;
	int result = dlgSearch.DoModal();

	if(result == 0)
	{
		if(!pData->m_contractsSet.IsOpen())
			pData->m_contractsSet.Open();
		pData->m_contractsSet.MoveFirst();
	}
	
	




	ClearDisplay();
	UpdateDisplay();		
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CContractsViewDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CContractsViewDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CContractsViewDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CContractsViewDlg::OnNewsearchButton() 
{
	int result;
	// going to the search dialog
	CSearch dlgSearch;
	dlgSearch.pData = pData;
	dlgSearch.pFlt = pFlt;
	result = dlgSearch.DoModal();	

	if(result ==1)
	{
		//does the same thing as the OnInitDialog()
		ClearDisplay();
		UpdateDisplay();

		FillResultsCombo();
	}

}

void CContractsViewDlg::UpdateDisplay()
{
	
	//this is so that I have the rtf crap from the DB in a nice safe place
	store_desc_contract1 = pData->m_contractsSet.m_desc_contract1;
	store_desc_contract2 = pData->m_contractsSet.m_desc_contract2;
	store_good_for_detail = pData->m_contractsSet.m_good_for_detail;
	store_tour_IT_code = pData->m_contractsSet.m_tour_IT_code;
	store_ticket_designator = pData->m_contractsSet.m_ticket_designator;
	store_endorsement_box = pData->m_contractsSet.m_endorsement_box;
	store_pay_method = pData->m_contractsSet.m_pay_method;
	store_deal_desc1 = pData->m_contractsSet.m_deal_desc1;
	store_deal_desc2 = pData->m_contractsSet.m_deal_desc2;
	store_specific_flights = pData->m_contractsSet.m_specific_flights;
	store_spfc_routing_origin = pData->m_contractsSet.m_spfc_routing_origin;
	store_spfc_routing_dest = pData->m_contractsSet.m_spfc_routing_dest;
	store_class_of_service = pData->m_contractsSet.m_class_of_service;
	store_PTA = pData->m_contractsSet.m_PTA;
	store_codeshare_connections = pData->m_contractsSet.m_codeshare_connections;
	store_spfc_exclusions = pData->m_contractsSet.m_spfc_exclusions;
	store_combine_ability = pData->m_contractsSet.m_combine_ability;
	store_apollo_frmt = pData->m_contractsSet.m_apollo_frmt;
	store_sabre_frmt = pData->m_contractsSet.m_sabre_frmt;
	store_misc_notes = pData->m_contractsSet.m_misc_notes;
	store_update_name = pData->m_contractsSet.m_update_name;
	store_contract_name = pData->m_contractsSet.m_contract_name;
	store_blackout_dates = pData->m_contractsSet.m_blackout_dates;

	m_AirlineName = pData->m_contractsSet.m_airline_name;	
	m_FirstTicketDate = pData->m_contractsSet.m_val_first_tckt;
	m_FirstTravelDate = pData->m_contractsSet.m_val_first_travel;
	m_HotDeal = pData->m_contractsSet.m_hot_deal;
	m_LastTicketDate = pData->m_contractsSet.m_val_last_tckt;
	m_LastTravelDate = pData->m_contractsSet.m_val_last_travel;
	m_SeeAirDeals = pData->m_contractsSet.m_air_deals_notebook;

	LoadCtlGoodFor();
	LoadCtlMajorDestination();
	LoadTypeofDeal();
	
	LoadMain();

	FillResultsCombo();

	UpdateData(FALSE);	
}

void CContractsViewDlg::LoadCtlGoodFor()
{
	//loads the listbox with names of values only if they are true
	if(pData->m_contractsSet.m_good_for_all)
		m_ctlGoodFor.AddString("All");	
	if(pData->m_contractsSet.m_good_for_MTALL)
		m_ctlGoodFor.AddString("MT All");
	if(pData->m_contractsSet.m_good_for_MTLELS)
		m_ctlGoodFor.AddString("MT Lels");
	if(pData->m_contractsSet.m_good_for_MTCorp)
		m_ctlGoodFor.AddString("Mt Corp");
	if(pData->m_contractsSet.m_good_for_A4L)
		m_ctlGoodFor.AddString("A4L");
	if(pData->m_contractsSet.m_good_for_ST)
		m_ctlGoodFor.AddString("ST");
	if(pData->m_contractsSet.m_good_for_detail != "")
		m_ctlGoodFor.AddString(pData->m_contractsSet.m_good_for_detail);
}

void CContractsViewDlg::LoadCtlMajorDestination()
{
	if(pData->m_contractsSet.m_md_us)
		m_ctlMajorDestination.AddString("United States");
	if(pData->m_contractsSet.m_md_eu)
		m_ctlMajorDestination.AddString("Europe");
	if(pData->m_contractsSet.m_md_asia)
		m_ctlMajorDestination.AddString("Asia");
	if(pData->m_contractsSet.m_md_south_pacific)
		m_ctlMajorDestination.AddString("South Pacific");
	if(pData->m_contractsSet.m_md_south_am)
		m_ctlMajorDestination.AddString("South America");
	if(pData->m_contractsSet.m_md_central_am)
		m_ctlMajorDestination.AddString("Central America");
	if(pData->m_contractsSet.m_md_latin_am)
		m_ctlMajorDestination.AddString("Latin America");
	if(pData->m_contractsSet.m_md_mexico)
		m_ctlMajorDestination.AddString("Mexico");
	if(pData->m_contractsSet.m_md_africa)
		m_ctlMajorDestination.AddString("Africa");
	if(pData->m_contractsSet.m_md_ca)
		m_ctlMajorDestination.AddString("Canada");
	if(pData->m_contractsSet.m_md_middle_east)
		m_ctlMajorDestination.AddString("Middle East");
	if(pData->m_contractsSet.m_md_russia)
		m_ctlMajorDestination.AddString("Russia");
}

void CContractsViewDlg::LoadTypeofDeal()
{

	if(pData->m_contractsSet.m_type_deal_pcomm)
		m_TypeofDeal.AddString("Percent Commission");
	if(pData->m_contractsSet.m_type_deal_pdisc)
		m_TypeofDeal.AddString("Percent Discount");
	if(pData->m_contractsSet.m_type_deal_dcomm)
		m_TypeofDeal.AddString("Dollar Commissin");
	if(pData->m_contractsSet.m_type_deal_ddisc)
		m_TypeofDeal.AddString("Dollar Discount");
	if(pData->m_contractsSet.m_type_deal_zone)
		m_TypeofDeal.AddString("Zone");
	if(pData->m_contractsSet.m_type_deal_bulk)
		m_TypeofDeal.AddString("Bulk");
	if(pData->m_contractsSet.m_type_deal_net)
		m_TypeofDeal.AddString("Net");
	if(pData->m_contractsSet.m_type_deal_upgrade)
		m_TypeofDeal.AddString("Upgrade");
	if(pData->m_contractsSet.m_type_deal_two_one)
		m_TypeofDeal.AddString("Two for One");
	if(pData->m_contractsSet.m_type_deal_other)
		m_TypeofDeal.AddString("Other");


}

void CContractsViewDlg::OnMovefirstButton() 
{
	if(!pData->m_contractsSet.IsOpen())
		pData->m_contractsSet.Open();

	if(pData->m_contractsSet.IsBOF())
		MessageBox("Already on first record.");

	else
		pData->m_contractsSet.MoveFirst();
	
	ClearDisplay();
	UpdateDisplay();
}

void CContractsViewDlg::ClearDisplay()
{
	//clears all displays
	m_AirlineName = "";
	m_ctlGoodFor.ResetContent();
	m_ctlMajorDestination.ResetContent();
	m_FirstTicketDate = COleDateTime::COleDateTime();
	m_FirstTravelDate = COleDateTime::COleDateTime();
	m_HotDeal = FALSE;
	m_LastTicketDate = COleDateTime::COleDateTime();
	m_LastTravelDate = COleDateTime::COleDateTime();
	m_SeeAirDeals = FALSE;
	m_TypeofDeal.ResetContent();

}

void CContractsViewDlg::OnMoveprevButton() 
{
	if(!pData->m_contractsSet.IsOpen())
		pData->m_contractsSet.Open();

	pData->m_contractsSet.MovePrev();

	if(pData->m_contractsSet.IsBOF())
	{
		pData->m_contractsSet.MoveNext();
		MessageBox("Already on first Record");
	}
	else
	{	
		ClearDisplay();
		UpdateDisplay();
	}
	
}

void CContractsViewDlg::OnMovenextButton() 
{
	if(!pData->m_contractsSet.IsOpen())
		pData->m_contractsSet.Open();

	
	pData->m_contractsSet.MoveNext();

	if(pData->m_contractsSet.IsEOF())
	{
		pData->m_contractsSet.MovePrev();
		MessageBox("Already on last Record");
	}
	else
	{	
		ClearDisplay();
		UpdateDisplay();
	}
	
}

void CContractsViewDlg::OnMovelastButton() 
{
	if(!pData->m_contractsSet.IsOpen())
		pData->m_contractsSet.Open();

	if(pData->m_contractsSet.IsEOF())
		MessageBox("Already on last record.");

	else
	{
		pData->m_contractsSet.MoveLast();
		ClearDisplay();
		UpdateDisplay();
	}	
}

//this is something that the client wanted (don't know why)
void CContractsViewDlg::FillResultsCombo()
{
	ctr_results.ResetContent();
	if(!pData->m_contractsSet.IsOpen())
		pData->m_contractsSet.Open();

	BOOL eof = FALSE;
	CString list;

	pData->m_contractsSet.MoveFirst();

	while(!eof)
	{
		list = pData->m_contractsSet.m_airline_name;
		list += CreateDestinationString();
		list += CreateTypeOfDealString();
		list += CreateValidDateString();
		list += CreateHotDealString();

		ctr_results.AddString(list);
		
		//check to see if it is really at end of file
		pData->m_contractsSet.MoveNext();
		if(pData->m_contractsSet.IsEOF())
			eof = TRUE;
	}

	pData->m_contractsSet.MoveFirst();

}

//simply to help fill line in combo
CString CContractsViewDlg::CreateDestinationString()
{
	CString str;

	if(pData->m_contractsSet.m_md_us)
		str += " US-";
	if(pData->m_contractsSet.m_md_eu)
		str += "Europe-";
	if(pData->m_contractsSet.m_md_asia)
		str += "Asia-";
	if(pData->m_contractsSet.m_md_south_pacific)
		str += "South Pacific-";
	if(pData->m_contractsSet.m_md_south_am)
		str += "South America-";
	if(pData->m_contractsSet.m_md_central_am)
		str += "Central America-";
	if(pData->m_contractsSet.m_md_latin_am)
		str += "Latin America-";
	if(pData->m_contractsSet.m_md_mexico)
		str += "Mexico-";
	if(pData->m_contractsSet.m_md_africa)
		str += "Africa-";
	if(pData->m_contractsSet.m_md_ca)
		str += "Canada-";
	if(pData->m_contractsSet.m_md_middle_east)
		str += "Middle East-";
	if(pData->m_contractsSet.m_md_russia)
		str += "Russia-";

	str += "|";
	return str;	
}
//another combo line filler
CString CContractsViewDlg::CreateTypeOfDealString()
{
	CString str;

	if(pData->m_contractsSet.m_type_deal_pcomm)
		str += "Percent Commission-";
	if(pData->m_contractsSet.m_type_deal_pdisc)
		str += "Percent Discount-";
	if(pData->m_contractsSet.m_type_deal_dcomm)
		str += "Dollar Commission-";
	if(pData->m_contractsSet.m_type_deal_ddisc)
		str += "Dollar Discount-";
	if(pData->m_contractsSet.m_type_deal_zone)
		str += "Zone-";
	if(pData->m_contractsSet.m_type_deal_bulk)
		str += "Bulk-";
	if(pData->m_contractsSet.m_type_deal_net)
		str += "Net-";
	if(pData->m_contractsSet.m_type_deal_upgrade)
		str += "Upgrade-";
	if(pData->m_contractsSet.m_type_deal_two_one)
		str += "Two for One-";
	if(pData->m_contractsSet.m_type_deal_other)
		str += "Other-";

	str += "|";

	return str;
	
}
//and yet another combo line filler
CString CContractsViewDlg::CreateHotDealString()
{
	CString str;
	if(pData->m_contractsSet.m_hot_deal)
		str = "HOT DEAL ";

	return str;
}
//I think Dan put this one in
CString CContractsViewDlg::CreateValidDateString()
{
	CString str;

	COleDateTime dt;
	dt = pData->m_contractsSet.m_val_first_tckt;
	str += dt.Format(LOCALE_NOUSEROVERRIDE, LANG_USER_DEFAULT);
	dt = pData->m_contractsSet.m_val_first_travel;
	str += dt.Format(LOCALE_NOUSEROVERRIDE, LANG_USER_DEFAULT);
	dt = pData->m_contractsSet.m_val_last_tckt;
	str += dt.Format(LOCALE_NOUSEROVERRIDE, LANG_USER_DEFAULT);
	dt = pData->m_contractsSet.m_val_last_travel;
	str += dt.Format(LOCALE_NOUSEROVERRIDE, LANG_USER_DEFAULT);
	dt = pData->m_contractsSet.m_val_exp_yr;
	str += dt.Format(LOCALE_NOUSEROVERRIDE, LANG_USER_DEFAULT);
	

	return str;
}

//to move around in the DB when user selects different combo sel
void CContractsViewDlg::OnSelchangeResults() 
{
	int sel = ctr_results.GetCurSel();
	
	if(sel != CB_ERR)
	{
		pData->m_contractsSet.SetAbsolutePosition(long(sel));
		ClearDisplay();
		UpdateDisplay();
	}
}

void CContractsViewDlg::LoadMain()
{
	m_main = "";
	/************************************************************
	//COMMENTED OUT STATEMENTS ARE PLAIN TEXT AND NOT RTF
	***********************************************************/
	if(store_contract_name != "")
		CreateString("Contract Name",store_contract_name , FALSE);
	if(store_desc_contract1 != "")
		CreateString("Description of Contract 1",store_desc_contract1, FALSE);
	if(store_desc_contract2 != "")
		CreateString("Description of Contract 2",store_desc_contract2 , FALSE);
	if(store_good_for_detail != "")
		CreateString("Good For Detail",store_good_for_detail, FALSE );
	if(store_tour_IT_code != "")
		CreateString("Tour/IT code",store_tour_IT_code , TRUE);
	if(store_ticket_designator != "")
		CreateString("Ticket Designator",store_ticket_designator , TRUE);
	if(store_endorsement_box != "")
		CreateString("Endorsement",store_endorsement_box , TRUE);
	if(store_pay_method != "")
		CreateString("Payment Method",store_pay_method , TRUE);
	if(store_deal_desc1 != "")
		CreateString("Deal Description 1",store_deal_desc1 , TRUE);
	if(store_deal_desc2 != "")
		CreateString("Deal Description 2",store_deal_desc2 , TRUE);
	if(store_specific_flights != "")
		CreateString("Specific Flights",store_specific_flights , TRUE);
	if(store_spfc_routing_origin != "")
		CreateString("Specific Routing Origination(s)", store_spfc_routing_origin , TRUE);
	if(store_spfc_routing_dest != "")
		CreateString("Specific Routing Destination",store_spfc_routing_dest , TRUE);
	if(store_class_of_service != "")
		CreateString("Class of Service",store_class_of_service , TRUE);
	if(store_blackout_dates != "")
		CreateString("Blackout Dates",store_blackout_dates , TRUE);
	if(store_PTA != "")
		CreateString("PTA",store_PTA , TRUE);
	if(store_codeshare_connections != "")
		CreateString("Codeshare Connections",store_codeshare_connections , TRUE);
	if(store_spfc_exclusions != "")
		CreateString("Specific Exclusions",store_spfc_exclusions , TRUE);
	if(store_combine_ability != "")
		CreateString("Combineability",store_combine_ability , TRUE);
	if(store_apollo_frmt != "")
		CreateString("Apollo Format",store_apollo_frmt , TRUE);
	if(store_sabre_frmt != "")
		CreateString("Sabre Format",store_sabre_frmt , TRUE);
	if(store_misc_notes != "")
		CreateString("Miscellaneous Notes",store_misc_notes, TRUE );
	if(store_update_name != "")
		CreateString("Update Name",store_update_name , FALSE);
	

/*
	For some stupid reason nothing will display if I set dwCookie to &m_main.
	The only way it will display anything in ctr_main is this way....
		copying it to another string and then passing that string's address
*/


	CString str = m_main;

	//setting the selection of the ctr_main to all
	CHARRANGE cr;
	cr.cpMin = 0;
	cr.cpMax = ctr_main.GetTextLength();
	ctr_main.SetSel(cr);

	EDITSTREAM es = {(DWORD)&str, 0, EditStreamCallback};

	ctr_main.StreamIn(SF_RTF | SFF_SELECTION, es);	
}

void CContractsViewDlg::CreateString(/*this is the title of the column*/ CString title,
									 /*rtf from DB*/ CString str,
									 /*whether it is palin text or rtf*/ BOOL rtf)
{
//rtf string (str) has prefix and post fix and everything else in it.
//need to take out
	/**************************************************************
	//THIS F() IS EXTREMELY FUDGED MEANT AS A TMEPORARY TEST
	***********************************************************/
	CString insert, temp;
	//removing prefix;
	int str_length, pre_length, post_length, get, main_length,temp_length, insert_length,
		bridge_length,return_length, title_length, ttl_length;


	
	
	if(rtf)
	{
		//if the string is not rtf then this is pointless and actually destructive
		str_length = str.GetLength();
		pre_length = rtfPrefix.GetLength();

		get = str_length - pre_length;

		insert = str.Right(get-3);

		str_length = insert.GetLength();
		post_length = rtfPostfix.GetLength();
		get = str_length - post_length;

		insert = insert.Left(get-5);
	}
	else
	{
		//just assinging the string over for consistancy
		insert = str;
	}


	//now we break up m_main to insert the insert string;

	
	post_length = rtfPostfix.GetLength();
	main_length = m_main.GetLength();

	if(main_length == 0)
		temp = rtfPrefix;

	else
	{
		get = main_length - post_length;

		temp = m_main.Left(get);
	}
	temp_length = temp.GetLength();
	insert_length = insert.GetLength();
	bridge_length = rtfBridge.GetLength();
	return_length = rtfReturn.GetLength();
	title_length = title.GetLength();
	ttl_length = rtfTitle.GetLength();
	post_length = rtfPostfix.GetLength();
	pre_length = rtfPrefix.GetLength();



	//THIS IS RIDICULOUS BUT DID IT THIS WAY TO MAKE IT EASY TO ADD IN AND TAKE OUT CSTRINGS
	//GETS THE TOTAL HOPEFUL LENGTH OF THE EVENTUAL CSTRING WITH RTF
	int buff = temp_length + return_length + bridge_length + ttl_length +
				title_length + return_length + insert_length +
				post_length;

	//create title
	//APPENDING ALL THE RTF STUFF IN A WAY SO IT WORKS
	temp += rtfReturn;
	temp += rtfBridge;
	temp += rtfTitle;
	temp += title;
	temp += rtfReturn;
	if(!rtf){buff = buff + bridge_length; temp += rtfBridge;}
	temp += insert;		
	temp += rtfPostfix;
	temp.GetBufferSetLength(buff);//setting the buffer to the length of the string
	m_main = temp;//setting the CString associated to the RichEdit 
	
	


}

//file scope callback f() for Streaming In
static DWORD CALLBACK EditStreamCallback(DWORD dwCookie, 
    LPBYTE pbBuff, LONG cb, LONG FAR *pcb)
{
	CString *pstr = (CString *)dwCookie;

	if(pstr->GetLength() < cb)
	{
		*pcb = pstr->GetLength();
		memcpy(pbBuff, (LPCSTR)*pstr, *pcb);
		pstr->Empty();
	}
	else
	{
		*pcb = cb;
		memcpy(pbBuff, (LPCSTR)*pstr, *pcb);
		*pstr = pstr->Right(pstr->GetLength() - cb);
	}
	return 0;
}


