// ContractsViewDlg.h : header file
//

#if !defined(AFX_CONTRACTSVIEWDLG_H__88BB0A07_21B6_11D3_B7EC_00A024EFE1AA__INCLUDED_)
#define AFX_CONTRACTSVIEWDLG_H__88BB0A07_21B6_11D3_B7EC_00A024EFE1AA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "Data.h"
#include "Filter.h"

/////////////////////////////////////////////////////////////////////////////
// CContractsViewDlg dialog
static DWORD CALLBACK EditStreamCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb); 
class CContractsViewDlg : public CDialog
{
// Construction
public:
	CContractsViewDlg(CWnd* pParent = NULL);	// standard constructor

	// CHANGED: This used to be a DDX variable and was screwing things up
	CString m_main;

	// creating pointer to the CData class
	CData *pData;
	CFilter *pFlt;

// Dialog Data
	//{{AFX_DATA(CContractsViewDlg)
	enum { IDD = IDD_CONTRACTSVIEW_DIALOG };
	CComboBox	ctr_results;
	CListBox	m_TypeofDeal;
	CListBox	m_ctlMajorDestination;
	CListBox	m_ctlGoodFor;
	CString	m_AirlineName;
	COleDateTime	m_FirstTravelDate;
	COleDateTime	m_FirstTicketDate;
	BOOL	m_HotDeal;
	COleDateTime	m_LastTicketDate;
	COleDateTime	m_LastTravelDate;
	CRichEditCtrl ctr_main;
	BOOL	m_SeeAirDeals;
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CContractsViewDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CContractsViewDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNewsearchButton();
	afx_msg void OnMovefirstButton();
	afx_msg void OnMoveprevButton();
	afx_msg void OnMovenextButton();
	afx_msg void OnMovelastButton();
	afx_msg void OnSelchangeResults();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void CreateString(CString title, CString str, BOOL rtf);
	void LoadMain();	
	CString CreateValidDateString();
	CString CreateHotDealString();
	CString CreateTypeOfDealString();
	CString CreateDestinationString();
	void FillResultsCombo();
	void ClearDisplay();
	void LoadTypeofDeal();
	void LoadCtlMajorDestination();
	void LoadCtlGoodFor();
	void UpdateDisplay();
	
	CString rtfPrefix;
	CString rtfPostfix;
	CString rtfBridge;
	CString rtfReturn;
	CString rtfTitle;

	


	
	CString	store_desc_contract1;
	CString	store_desc_contract2;
	CString	store_good_for_detail;
	CString	store_tour_IT_code;
	CString	store_ticket_designator;
	CString	store_endorsement_box;
	CString	store_pay_method;
	CString	store_deal_desc1;
	CString	store_deal_desc2;
	CString	store_specific_flights;
	CString	store_spfc_routing_origin;
	CString	store_spfc_routing_dest;
	CString	store_class_of_service;
	CString	store_PTA;
	CString	store_codeshare_connections;
	CString	store_spfc_exclusions;
	CString	store_combine_ability;
	CString	store_apollo_frmt;
	CString	store_sabre_frmt;
	CString	store_misc_notes;
	CString	store_update_name;
	CString	store_contract_name;
	CString	store_blackout_dates;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONTRACTSVIEWDLG_H__88BB0A07_21B6_11D3_B7EC_00A024EFE1AA__INCLUDED_)
