// OleDT.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "OleDT.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COleDT

COleDT::COleDT()
{
	max = 12;
	Initialize();
}

COleDT::~COleDT()
{
}


BEGIN_MESSAGE_MAP(COleDT, CWnd)
	//{{AFX_MSG_MAP(COleDT)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// COleDT message handlers

BOOL COleDT::Add(COleDateTime val)
{
	total++;
	if(total < max)
	{
		odt[total] = val;
		return TRUE;
	}
	else
	{
		MessageBox("You have exceeded the maximum values of Date parameters for a search.  Please try again and limit your search to only 12 parameters.");
		return FALSE;
	}

}

void COleDT::Initialize()
{
	int itor;

	for(itor = 0; itor < max; itor++)
	{
		odt[itor] = COleDateTime::COleDateTime();
	}

	total = 0;
}

BOOL COleDT::Get(int itor, COleDateTime & dt)
{
	if(itor < max)
	{
		dt = odt[itor];
		return TRUE;
	}
	else
	{
		MessageBox("Your retrieval request has extended into the stack.  Please yell at Dan Canham.");
		return FALSE;
	}
}

int COleDT::GetMax()
{
	return total;
}

BOOL COleDT::Add(int col, COleDateTime dt)
{
	total++;
	if(total < max)
	{
		column[total] = col;
		odt[total] = dt;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL COleDT::Get(int itor, int & col, COleDateTime & dt)
{
	if(itor < max)
	{
		col = column[itor];
		dt = odt[itor];
		return TRUE;
	}
	else
		return FALSE;
}

BOOL COleDT::Add(int col, COleDateTime dt, CString op)
{
	total++;
	if(total < max)
	{
		column[total] = col;
		odt[total] = dt;
		oper[total] = op;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL COleDT::Get(int itor, int & col, COleDateTime & dt, CString & op)
{
	if(itor < max)
	{
		col = column[itor];
		dt = odt[itor];
		op = oper[itor];
		return TRUE;
	}
	else
		return FALSE;
}
