// All.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "All.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAll

CAll::CAll()
{
	total = -1;
	max = 126;
	Initialize();
}

CAll::~CAll()
{
}


BEGIN_MESSAGE_MAP(CAll, CWnd)
	//{{AFX_MSG_MAP(CAll)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CAll message handlers

int CAll::GetMax()
{
	return total;
}

BOOL CAll::Add(int col, COleDateTime dt)
{
	total++;
	if(total < max)
	{
		type[total] = CT_COLEDATETIME;
		odt[total] = dt;
		column[total] = col;

		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL CAll::Add(int col, CString st)
{
	total++;
	if(total < max)
	{
		type[total] = CT_CSTRING;
		str[total] = st;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL CAll::Add(int col, BOOL bl)
{
	total++;
	if(total < max)
	{
		type[total] = CT_BOOL;
		b[total] = bl;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

void CAll::Initialize()
{
	int itor;

	for(itor = 0; itor < max; itor++)
	{
		b[itor] = FALSE;
		conj[itor] = "AND";
		odt[itor] = COleDateTime::COleDateTime();
		str[itor] = "";
		type[itor] = -1;
		op[itor] = "=";
		column[itor] = -1;
	}
}

BOOL CAll::Add(int col, COleDateTime dt, CString o)
{
	total++;
	if(total < max)
	{
		type[total] = CT_COLEDATETIME;
		odt[total] = dt;
		op[total] = o;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}

}

BOOL CAll::Add(int col, COleDateTime dt, CString o, CString con)
{
	total++;
	if(total < max)
	{
		type[total] = CT_COLEDATETIME;
		odt[total] = dt;
		op[total] = o;
		conj[total] = con;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL CAll::Add(int col, BOOL bl, CString o)
{
	total++;
	if(total < max)
	{
		type[total] = CT_BOOL;
		b[total] = bl;
		op[total] = o;
		column[total] = col;
		return TRUE;
	}
	else
	{ 
		total--;
		return FALSE;
	}
}

BOOL CAll::Add(int col, BOOL bl, CString o, CString con)
{
	total++;
	if(total < max)
	{
		type[total] = CT_BOOL;
		b[total] = bl;
		op[total] = o;
		conj[total] = con;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL CAll::Add(int col, CString st, CString o)
{
	total++;
	if(total < max)
	{
		type[total] = CT_CSTRING;
		str[total] = st;
		op[total] = o;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total--;
		return FALSE;
	}
}

BOOL CAll::Add(int col, CString st, CString o, CString con)
{
	total++;
	if(total < max)
	{
		type[total] = CT_CSTRING;
		str[total] = st;
		op[total] = o;
		conj[total] = con;
		column[total] = col;
		return TRUE;
	}
	else
	{
		total++;
		return FALSE;
	}
}

BOOL CAll::Get(int itor, int & t)
{
	if(itor < max)
	{
		t = type[itor];
		return TRUE;
	}
	else
		return FALSE;
}

BOOL CAll::Get(int itor, int &col, CString &oper, CString &con, COleDateTime &dt)
{
	if(itor < max)
	{
		dt = odt[itor];
		oper = op[itor];
		col = column[itor];
		return TRUE;
	}
	else
		return FALSE;

}

BOOL CAll::Get(int itor, int &col, CString &oper, CString &con, BOOL & bl)
{
	if(itor < max)
	{
		bl = b[itor];
		oper = op[itor];
		col = column[itor];
		return TRUE;
	}
	else 
		return FALSE;
}

BOOL CAll::Get(int itor, int &col, CString &oper, CString &con, CString & st)
{
	if(itor < max)
	{
		st = str[itor];
		oper = op[itor];
		col = column[itor];
		con = conj[itor];
		return TRUE;
	}
	else 
		return FALSE;
}

void CAll::Undo()
{
	//setting the last thing added to the default values
	b[total] = FALSE;
	conj[total] = "AND";
	odt[total] = COleDateTime::COleDateTime();
	str[total] = "";
	type[total] = -1;
	op[total] = "=";
	column[total] = -1;

	total--;

}
