// Parser.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "Parser.h"

#include "Globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CParser

CParser::CParser()
{
	total = -1;
	max = 22;
}

CParser::~CParser()
{
}


BEGIN_MESSAGE_MAP(CParser, CWnd)
	//{{AFX_MSG_MAP(CParser)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CParser message handlers

CParser::CParser(CData * pDb)
{
	pData = pDb;
	total = -1;
	max = 22;
}

void CParser::CreateList()
{	
	
	
	if(pData->m_contractsSet.m_desc_contract1!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_DESC_CONTRACT1;
			titles[total] = "Description of Contract1";
			data[total] = pData->m_contractsSet.m_desc_contract1;
		}
		else
			total--;

	}
	if(pData->m_contractsSet.m_desc_contract2!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_DESC_CONTRACT2;
			titles[total] = "Description of Contract2";
			data[total] = pData->m_contractsSet.m_desc_contract2;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_good_for_detail!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_GOOD_FOR_DETAIL;
			titles[total] = "Good For Detail";
			data[total] = pData->m_contractsSet.m_good_for_detail;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_tour_IT_code!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_TOUR_IT_CODE;
			titles[total] = "Tour IT Code";
			data[total] = pData->m_contractsSet.m_tour_IT_code;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_ticket_designator!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_TICKET_DESIGNATOR;
			titles[total] = "Ticket Designator";
			data[total] = pData->m_contractsSet.m_ticket_designator;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_endorsement_box!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_ENDORSEMENT_BOX;
			titles[total] = "Endorsement Box";
			data[total] = pData->m_contractsSet.m_endorsement_box;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_pay_method!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_PAY_METHOD;
			titles[total] = "Pay Method";
			data[total] = pData->m_contractsSet.m_pay_method;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_deal_desc1!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_DEAL_DESC1;
			titles[total] = "Deal Description1";
			data[total] = pData->m_contractsSet.m_deal_desc1;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_deal_desc2!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_DEAL_DESC2;
			titles[total] = "Deal Description2";
			data[total] = pData->m_contractsSet.m_deal_desc2;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_specific_flights!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_SPECIFIC_FLIGHTS;
			titles[total] = "Specific Flights";
			data[total] = pData->m_contractsSet.m_specific_flights;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_spfc_routing_origin!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_SPFC_ROUTING_ORIGIN;
			titles[total] = "Specific Routing Oringin";
			data[total] = pData->m_contractsSet.m_spfc_routing_origin;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_spfc_routing_dest!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_SPFC_ROUTING_DEST;
			titles[total] = "Specific Routing Destination";
			data[total] = pData->m_contractsSet.m_spfc_routing_dest;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_class_of_service!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_CLASS_OF_SERVICE;
			titles[total] = "Class of Service";
			data[total] = pData->m_contractsSet.m_class_of_service;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_PTA!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_PTA;
			titles[total] = "PTA";
			data[total] = pData->m_contractsSet.m_PTA;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_codeshare_connections!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_CODESHARE_CONNECTIONS;
			titles[total] = "Codeshare Connections";
			data[total] = pData->m_contractsSet.m_codeshare_connections;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_spfc_exclusions!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_SPFC_EXCLUSIONS;
			titles[total] = "Specific Exclusions";
			data[total] = pData->m_contractsSet.m_spfc_exclusions;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_combine_ability!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_COMBINE_ABILITY;
			titles[total] = "Combine Ability";
			data[total] = pData->m_contractsSet.m_combine_ability;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_apollo_frmt!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_APOLLO_FRMT;
			titles[total] = "Apollo Format";
			data[total] = pData->m_contractsSet.m_apollo_frmt;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_sabre_frmt!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_SABRE_FRMT;
			titles[total] = "Sabre Format";
			data[total] = pData->m_contractsSet.m_sabre_frmt;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_misc_notes!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_MISC_NOTES;
			titles[total] = "Misc. Notes";
			data[total] = pData->m_contractsSet.m_misc_notes;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_update_name!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_UPDATE_NAME;
			titles[total] = "Update Name";
			data[total] = pData->m_contractsSet.m_update_name;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_contract_name!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_CONTRACT_NAME;
			titles[total] = "Contract Name";
			data[total] = pData->m_contractsSet.m_contract_name;
		}
		else
			total--;
	}
	if(pData->m_contractsSet.m_blackout_dates!="")
	{
		total++;
		if(total < max)
		{
			column[total] = CONTRACT_BLACKOUT_DATES;
			titles[total] = "Black Out Dates";
			data[total] = pData->m_contractsSet.m_blackout_dates;
		}
		else
			total--;
	}



}

void CParser::AppendString()
{
	int itor;

	for(itor = 0; itor < total; itor++)
	{
		full += titles[itor];
		full += 0x0D;
		full += data[itor];
	}
}

CString CParser::CreateString()
{
	CreateList();
	AppendString();

	return full;
}

int CParser::GetMax()
{
	return total;
}
