#if !defined(AFX_SEARCH_H__8944D6A3_21BA_11D3_B7EC_00A024EFE1AA__INCLUDED_)
#define AFX_SEARCH_H__8944D6A3_21BA_11D3_B7EC_00A024EFE1AA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Search.h : header file
//
#include "All.h"
#include "Data.h"
#include "Filter.h"

/////////////////////////////////////////////////////////////////////////////
// CSearch dialog

class CSearch : public CDialog
{
// Construction
public:
	CSearch(CWnd* pParent = NULL);   // standard constructor

	// creating pointer to the CData class
	CData *pData;
	CFilter *pFlt;

// Dialog Data
	//{{AFX_DATA(CSearch)
	enum { IDD = IDD_SEARCH_DIALOG };
	CComboBox	c_ContractName;
	CComboBox	c_AirlineName;
	BOOL	m_DestinationAsia;
	BOOL	m_DestinationCentralAmerica;
	BOOL	m_DestinationEurope;
	BOOL	m_DestinationMexico;
	BOOL	m_DestinationMiddleEast;
	BOOL	m_DestinationRussia;
	BOOL	m_DestinationSouthAmerica;
	BOOL	m_DestinationSouthPacific;
	BOOL	m_DestinationUS;
	BOOL	m_DestinationCanada;
	BOOL	m_DestinationLatinAmerica;
	BOOL	m_GoodforA4L;
	BOOL	m_GoodforAll;
	BOOL	m_GoodforMTAll;
	BOOL	m_GoodforMTCorp;
	BOOL	m_GoodforMTLeis;
	BOOL	m_GoodforST;
	BOOL	m_HotDeals;
	BOOL	m_DealBulk;
	BOOL	m_DealDolComm;
	BOOL	m_DealDolDisc;
	BOOL	m_DealNet;
	BOOL	m_DealPerComm;
	BOOL	m_DealPerDisc;
	BOOL	m_DealUpgrade;
	BOOL	m_DealZone;
	CString	m_airline_name;
	CString	m_contract_name;
	BOOL	m_DestinationAfrica;
	BOOL	m_DealOther;
	BOOL	m_Deal2for1;
	//}}AFX_DATA

	CAll all;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSearch)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSearch)
	afx_msg void OnCancelButton();
	afx_msg void OnDosearchButton();
	afx_msg void OnHotdealsCheck();
	afx_msg void OnKillfocusSearchfirstticketdateEdit();
	afx_msg void OnSelchangeAirlinenameCombo();
	afx_msg void OnSelchangeContractnameCombo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL OnInitDialog();
	void CheckCreate();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEARCH_H__8944D6A3_21BA_11D3_B7EC_00A024EFE1AA__INCLUDED_)
