// daoAirlineName.cpp : implementation file
//

#include "stdafx.h"
#include "ContractsView.h"
#include "daoAirlineName.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CdaoAirlineName

IMPLEMENT_DYNAMIC(CdaoAirlineName, CDaoRecordset)

CdaoAirlineName::CdaoAirlineName(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CdaoAirlineName)
	m_airline_name = _T("");
	m_nFields = 1;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenDynaset;
}


CString CdaoAirlineName::GetDefaultDBName()
{
	return _T("c:\\apps\\Airdeals\\contracts.mdb");
}

CString CdaoAirlineName::GetDefaultSQL()
{
	return _T("[airline_name]");
}

void CdaoAirlineName::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CdaoAirlineName)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Text(pFX, _T("[airline_name]"), m_airline_name);
	//}}AFX_FIELD_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CdaoAirlineName diagnostics

#ifdef _DEBUG
void CdaoAirlineName::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CdaoAirlineName::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
