#if !defined(AFX_DAOCONTRACTS_H__4EA91CF4_21B0_11D3_8F2A_00A024EFE0BF__INCLUDED_)
#define AFX_DAOCONTRACTS_H__4EA91CF4_21B0_11D3_8F2A_00A024EFE0BF__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// daoContracts.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CdaoContracts DAO recordset



class CdaoContracts : public CDaoRecordset
{
public:
	void SetNull(int param);
	CdaoContracts(CDaoDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CdaoContracts)

// Field/Param Data
	//{{AFX_FIELD(CdaoContracts, CDaoRecordset)
	CString	m_airline_name;
	CString	m_desc_contract1;
	CString	m_desc_contract2;
	BOOL	m_hot_deal;
	BOOL	m_air_deals_notebook;
	BOOL	m_md_us;
	BOOL	m_md_eu;
	BOOL	m_md_asia;
	BOOL	m_md_south_pacific;
	BOOL	m_md_south_am;
	BOOL	m_md_central_am;
	BOOL	m_md_latin_am;
	BOOL	m_md_mexico;
	BOOL	m_md_africa;
	BOOL	m_md_ca;
	BOOL	m_md_middle_east;
	BOOL	m_md_russia;
	BOOL	m_good_for_all;
	BOOL	m_good_for_MTALL;
	BOOL	m_good_for_MTLELS;
	BOOL	m_good_for_MTCorp;
	BOOL	m_good_for_A4L;
	BOOL	m_good_for_ST;
	CString	m_good_for_detail;
	BOOL	m_type_deal_pcomm;
	BOOL	m_type_deal_pdisc;
	BOOL	m_type_deal_dcomm;
	BOOL	m_type_deal_ddisc;
	BOOL	m_type_deal_zone;
	BOOL	m_type_deal_bulk;
	BOOL	m_type_deal_net;
	BOOL	m_type_deal_upgrade;
	BOOL	m_type_deal_two_one;
	BOOL	m_type_deal_other;
	CString	m_tour_IT_code;
	COleDateTime	m_val_first_tckt;
	COleDateTime	m_val_first_travel;
	COleDateTime	m_val_last_tckt;
	COleDateTime	m_val_last_travel;
	COleDateTime	m_val_exp_yr;
	BOOL	m_val_start;
	BOOL	m_val_complete;
	CString	m_ticket_designator;
	CString	m_endorsement_box;
	CString	m_pay_method;
	CString	m_deal_desc1;
	CString	m_deal_desc2;
	CString	m_specific_flights;
	CString	m_spfc_routing_origin;
	CString	m_spfc_routing_dest;
	CString	m_class_of_service;
	CString	m_PTA;
	CString	m_codeshare_connections;
	CString	m_spfc_exclusions;
	CString	m_combine_ability;
	CString	m_apollo_frmt;
	CString	m_sabre_frmt;
	CString	m_misc_notes;
	COleDateTime	m_update_date;
	CString	m_update_name;
	long	m_contract_id;
	CString	m_contract_name;
	CString	m_blackout_dates;
	//}}AFX_FIELD

	//parameters
	COleDateTime	m_val_first_tcktParam;
	COleDateTime	m_val_first_travelParam;
	COleDateTime	m_val_last_tcktParam;
	COleDateTime	m_val_last_travelParam;
	COleDateTime	m_val_exp_yrParam;
	COleDateTime	m_update_dateParam;
	BOOL	m_hot_dealParam;
	BOOL	m_air_deals_notebookParam;
	BOOL	m_md_usParam;
	BOOL	m_md_euParam;
	BOOL	m_md_asiaParam;
	BOOL	m_md_south_pacificParam;
	BOOL	m_md_south_amParam;
	BOOL	m_md_central_amParam;
	BOOL	m_md_latin_amParam;
	BOOL	m_md_mexicoParam;
	BOOL	m_md_africaParam;
	BOOL	m_md_caParam;
	BOOL	m_md_middle_eastParam;
	BOOL	m_md_russiaParam;
	BOOL	m_good_for_allParam;
	BOOL	m_good_for_MTALLParam;
	BOOL	m_good_for_MTLELSParam;
	BOOL	m_good_for_MTCorpParam;
	BOOL	m_good_for_A4LParam;
	BOOL	m_good_for_STParam;
	BOOL	m_type_deal_pcommParam;
	BOOL	m_type_deal_pdiscParam;
	BOOL	m_type_deal_dcommParam;
	BOOL	m_type_deal_ddiscParam;
	BOOL	m_type_deal_zoneParam;
	BOOL	m_type_deal_bulkParam;
	BOOL	m_type_deal_netParam;
	BOOL	m_type_deal_upgradeParam;
	BOOL	m_type_deal_two_oneParam;
	BOOL	m_type_deal_otherParam;
	BOOL	m_val_startParam;
	BOOL	m_val_completeParam;
	long	m_contract_idParam;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CdaoContracts)
	public:
	virtual CString GetDefaultDBName();		// Default database name
	virtual CString GetDefaultSQL();		// Default SQL for Recordset
	virtual void DoFieldExchange(CDaoFieldExchange* pFX);  // RFX support
	//}}AFX_VIRTUAL

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAOCONTRACTS_H__4EA91CF4_21B0_11D3_8F2A_00A024EFE0BF__INCLUDED_)


